import request from '~/utils/request';
import type {ApiResult, PageResult} from '@/api';
import type {User, UserParam} from './model';
import {SERVER_API_URL} from '@/config';

/**
 * 分页查询用户
 */
export async function pageUsers(params: UserParam) {
    const res = await request.get<ApiResult<PageResult<User>>>(
        SERVER_API_URL + '/system/user/page',
        {params}
    );
    if (res.code === 0) {
        return res.data;
    }
    return Promise.reject(new Error(res.message));
}

/**
 * 查询用户列表
 */
export async function listUsers(params?: UserParam) {
    const res = await request.get<ApiResult<User[]>>(
        SERVER_API_URL + '/system/user',
        {
            params
        }
    );
    if (res.code === 0 && res.data) {
        return res.data;
    }
    return Promise.reject(new Error(res.message));
}

/**
 * 查询用户列表
 */
export async function getStaffs(params?: UserParam) {
    const res = await request.get<ApiResult<User[]>>(
        SERVER_API_URL + '/system/user',
        {
            params
        }
    );
    if (res.code === 0 && res.data) {
        return res.data;
    }
    return Promise.reject(new Error(res.message));
}

/**
 * 查询用户列表
 */
export async function getCompanyList(params?: UserParam) {
    const res = await request.get<ApiResult<User[]>>(
        SERVER_API_URL + '/system/user',
        {
            params
        }
    );
    if (res.code === 0 && res.data) {
        return res.data;
    }
    return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询用户
 */
export async function getUser(id: number) {
    const res = await request.get<ApiResult<User>>(
        SERVER_API_URL + '/system/user/' + id
    );
    if (res.code === 0 && res.data) {
        return res.data;
    }
    return Promise.reject(new Error(res.message));
}

/**
 * 添加用户
 */
export async function addUser(data: User) {
    const res = await request.post<ApiResult<unknown>>(
        SERVER_API_URL + '/system/user',
        data
    );
    if (res.code === 0) {
        return res.message;
    }
    return Promise.reject(new Error(res.message));
}

/**
 * 修改用户
 */
export async function updateUser(data: User) {
    const res = await request.put<ApiResult<unknown>>(
        SERVER_API_URL + '/system/user',
        data
    );
    if (res.code === 0) {
        return res.message;
    }
    return Promise.reject(new Error(res.message));
}

/**
 * 删除用户
 */
export async function removeUser(id?: number) {
    const res = await request.del<ApiResult<unknown>>(
        SERVER_API_URL + '/system/user/' + id
    );
    if (res.code === 0) {
        return res.message;
    }
    return Promise.reject(new Error(res.message));
}

/**
 * 批量删除用户
 */
export async function removeUsers(data: (number | undefined)[]) {
    const res = await request.del<ApiResult<unknown>>(
        SERVER_API_URL + '/system/user/batch',
        {
            data
        }
    );
    if (res.code === 0) {
        return res.message;
    }
    return Promise.reject(new Error(res.message));
}

/**
 * 修改用户状态
 */
export async function updateUserStatus(userId?: number, status?: number) {
    const res = await request.put<ApiResult<unknown>>(
        SERVER_API_URL + '/system/user/status',
        {
            userId,
            status
        }
    );
    if (res.code === 0) {
        return res.message;
    }
    return Promise.reject(new Error(res.message));
}

/**
 * 修改推荐状态
 */
export async function updateUserRecommend(form: any) {
    const res = await request.put<ApiResult<unknown>>(
        SERVER_API_URL + '/system/user/recommend',
        form
    );
    if (res.code === 0) {
        return res.message;
    }
    return Promise.reject(new Error(res.message));
}

/**
 * 重置用户密码
 */
export async function updateUserPassword(userId?: number, password = '123456') {
    const res = await request.put<ApiResult<unknown>>(
        SERVER_API_URL + '/system/user/password',
        {
            userId,
            password
        }
    );
    if (res.code === 0) {
        return res.message;
    }
    return Promise.reject(new Error(res.message));
}

/**
 * 导入用户
 */
export async function importUsers(file: File) {
    const formData = new FormData();
    formData.append('file', file);
    const res = await request.post<ApiResult<unknown>>(
        SERVER_API_URL + '/system/user/import',
        formData
    );
    if (res.code === 0) {
        return res.message;
    }
    return Promise.reject(new Error(res.message));
}

/**
 * 检查用户是否存在
 */
export async function checkExistence(
    field: string,
    value: string,
    id?: number
) {
    const res = await request.get<ApiResult<unknown>>(
        SERVER_API_URL + '/system/user/existence',
        {
            params: {field, value, id}
        }
    );
    if (res.code === 0) {
        return res.message;
    }
    return Promise.reject(new Error(res.message));
}

/**
 * 统计用户余额
 */
export async function countUserBalance(params?: UserParam) {
    const res = await request.get<ApiResult<unknown>>(
        SERVER_API_URL + '/system/user/countUserBalance',
        {
            params
        }
    );
    if (res.code === 0 && res.data) {
        return res.data;
    }
    return Promise.reject(new Error(res.message));
}
